	.text
	xdef DrawGrayTiles8B

| Affiche directement les tiles dans 2 buffers de 3840 octets chacun

| Input :
| a0.l : adresse du tableau de tiles (bytes), positionne vers le premier tile  afficher
| a1.l : adresse du buffer destination (1)
| a4.l : adresse du buffer destination (2)
| a2.l : adresse du tableau de sprites 8x8
| d2.w : largeur de la map

| Drtuit : d0-d2/a0-a1

DrawGrayTiles8B:
    movem.l  %d3/%a2-%a4,-(%a7)

    moveq.l  #30-1,%d3
PutPlane_DrawGrayTiles8B:
    moveq.l  #16-1,%d1
PutCol_DrawGrayTiles8B:
    clr.w    %d0
    move.b   (%a0),%d0		| d0 = num_sprt
    lsl.w    #4,%d0		| d0 *= 8*2
    lea.l    0(%a2,%d0.w),%a3	| a3 = sprt

    moveq.l  #1,%d0
PutTile_DrawGrayTiles8B:
    move.b   (%a3)+,(%a1)
    move.b   (%a3)+,(%a4)

    move.b   (%a3)+,30(%a1)
    move.b   (%a3)+,30(%a4)

    move.b   (%a3)+,30*2(%a1)
    move.b   (%a3)+,30*2(%a4)

    move.b   (%a3)+,30*3(%a1)
    move.b   (%a3)+,30*3(%a4)

    lea.l    30*4(%a1),%a1
    lea.l    30*4(%a4),%a4

    dbf      %d0,PutTile_DrawGrayTiles8B

    adda.w   %d2,%a0
    dbf      %d1,PutCol_DrawGrayTiles8B

    lea.l    -3840+1(%a1),%a1	| next column
    move.w   %d2,%d1
    lsl.w    #4,%d1
    subq.w   #1,%d1		| d1 = larg_map*16 - 1
    suba.l   %d1,%a0

    dbf      %d3,PutPlane_DrawGrayTiles8B

    movem.l  (%a7)+,%d3/%a2-%a4
    rts
